#!/usr/bin/env python

# EXTRA OPERATIONS:
#  - Check MDU.
#  - Check AT.
#  - Make a BOX available (BOX to workspace).
#  - Make a TRAY available (TRAY to workspace).
#  - Add SPARE UNITS to a BOX.

import sys
import rospy
import roslib
import message_filters
import ast

if __name__ == '__main__':
    try:
	
	rospy.init_node("AKS_EXTRA", log_level = rospy.INFO)

	# ====================================================================================================== #

	print " ---------- EXTRA OPERATIONS ---------- "
	print " ====================================== " 
	EXIT = False
	
	while (EXIT == False):

		print "\n"
		print "MENU:"
		print "1. Check MDU.txt file."
		print "2. Check AT.txt file."
		print "3. Make a BOX available (BOX to workspace)."
		print "4. Add SPARE UNITS to a BOX."
		print "5. Make a TRAY available (TRAY to workspace)."
		print "0. EXIT."
		print "---------------------------------------------"
		OPT = raw_input("Please select: ")
		print "\n"

		if (OPT == "1"):

			# MDU.txt file is opened, and INFO is saved to bolts, nuts and washers dictionaries:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "r") as file:

				f = file.readlines()
		
				i = 1
				for line in f:	
					if i == 1:
						Bolts = ast.literal_eval(line)
					elif i == 2:
						Nuts = ast.literal_eval(line)
					elif i == 3:
						Washers = ast.literal_eval(line)
					else: 
						break
					i = i + 1	
		
				file.close()

			print " ~~~~~~~~~~~~ MDU.txt ~~~~~~~~~~~~"
			print " ================================="
			print " M2 BOLTS:"
			print "   - Slot 3.1 -> " + str(Bolts["M2Bolts1N"]) + ", Available: " + str(Bolts["M2Bolts1A"])
			print "   - Slot 3.2 -> " + str(Bolts["M2Bolts2N"]) + ", Available: " + str(Bolts["M2Bolts2A"])
			print "   - Slot 3.3 -> " + str(Bolts["M2Bolts3N"]) + ", Available: " + str(Bolts["M2Bolts3A"])
			print " M3 BOLTS:"
			print "   - Slot 3.4 -> " + str(Bolts["M3Bolts1N"]) + ", Available: " + str(Bolts["M3Bolts1A"])
			print "   - Slot 3.5 -> " + str(Bolts["M3Bolts2N"]) + ", Available: " + str(Bolts["M3Bolts2A"])
			print "   - Slot 3.6 -> " + str(Bolts["M3Bolts3N"]) + ", Available: " + str(Bolts["M3Bolts3A"])
			print " M4 BOLTS:"
			print "   - Slot 3.7 -> " + str(Bolts["M4Bolts1N"]) + ", Available: " + str(Bolts["M4Bolts1A"])
			print "   - Slot 3.8 -> " + str(Bolts["M4Bolts2N"]) + ", Available: " + str(Bolts["M4Bolts2A"])
			print "   - Slot 3.9 -> " + str(Bolts["M4Bolts3N"]) + ", Available: " + str(Bolts["M4Bolts3A"])
			print " ================================="
			print " M2 Nuts:"
			print "   - Slot 2.1 -> " + str(Nuts["M2Nuts1N"]) + ", Available: " + str(Nuts["M2Nuts1A"])
			print "   - Slot 2.2 -> " + str(Nuts["M2Nuts2N"]) + ", Available: " + str(Nuts["M2Nuts2A"])
			print "   - Slot 2.3 -> " + str(Nuts["M2Nuts3N"]) + ", Available: " + str(Nuts["M2Nuts2A"])
			print " M3 Nuts:"
			print "   - Slot 2.4 -> " + str(Nuts["M3Nuts1N"]) + ", Available: " + str(Nuts["M3Nuts1A"])
			print "   - Slot 2.5 -> " + str(Nuts["M3Nuts2N"]) + ", Available: " + str(Nuts["M3Nuts2A"])
			print "   - Slot 2.6 -> " + str(Nuts["M3Nuts3N"]) + ", Available: " + str(Nuts["M3Nuts3A"])
			print " M4 Nuts:"
			print "   - Slot 2.7 -> " + str(Nuts["M4Nuts1N"]) + ", Available: " + str(Nuts["M4Nuts1A"])
			print "   - Slot 2.8 -> " + str(Nuts["M4Nuts2N"]) + ", Available: " + str(Nuts["M4Nuts2A"])
			print "   - Slot 2.9 -> " + str(Nuts["M4Nuts3N"]) + ", Available: " + str(Nuts["M4Nuts3A"])
			print " ================================="
			print " M2 Washers:"
			print "   - Slot 1.1 -> " + str(Washers["M2Washers1N"]) + ", Available: " + str(Washers["M2Washers1A"])
			print "   - Slot 1.2 -> " + str(Washers["M2Washers2N"]) + ", Available: " + str(Washers["M2Washers2A"])
			print "   - Slot 1.3 -> " + str(Washers["M2Washers3N"]) + ", Available: " + str(Washers["M2Washers3A"])
			print " M3 Washers:"
			print "   - Slot 1.4 -> " + str(Washers["M3Washers1N"]) + ", Available: " + str(Washers["M3Washers1A"])
			print "   - Slot 1.5 -> " + str(Washers["M3Washers2N"]) + ", Available: " + str(Washers["M3Washers2A"])
			print "   - Slot 1.6 -> " + str(Washers["M3Washers3N"]) + ", Available: " + str(Washers["M3Washers3A"])
			print " M4 Washers:"
			print "   - Slot 1.7 -> " + str(Washers["M4Washers1N"]) + ", Available: " + str(Washers["M4Washers1A"])
			print "   - Slot 1.8 -> " + str(Washers["M4Washers2N"]) + ", Available: " + str(Washers["M4Washers2A"])
			print "   - Slot 1.9 -> " + str(Washers["M4Washers3N"]) + ", Available: " + str(Washers["M4Washers3A"])
		
		elif (OPT == "2"):

			# AT.txt file is opened, and INFO is saved to AT dictionary:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "r") as file:
	
				f = file.readline()
				AT = ast.literal_eval(f)
				file.close()

			print " ~~~~~~~~~ AT.txt ~~~~~~~~~"
			print " =========================="
			if (AT["Tray1"] == "Y"):
				print(" - Tray 1: AVAILABLE")
			else:
				print(" - Tray 1: NOT AVAILABLE")
			if (AT["Tray2"] == "Y"):
				print(" - Tray 2: AVAILABLE")
			else:
				print(" - Tray 2: NOT AVAILABLE")
			if (AT["Tray3"] == "Y"):
				print(" - Tray 3: AVAILABLE")
			else:
				print(" - Tray 3: NOT AVAILABLE") 

		elif (OPT == "3"):

			# MDU.txt file is opened, and INFO is saved to bolts, nuts and washers dictionaries:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "r") as file:

				f = file.readlines()
		
				i = 1
				for line in f:	
					if i == 1:
						Bolts = ast.literal_eval(line)
					elif i == 2:
						Nuts = ast.literal_eval(line)
					elif i == 3:
						Washers = ast.literal_eval(line)
					else: 
						break
					i = i + 1	
		
				file.close()
			
			print " ~~~~~ BOX BACK TO MDU ~~~~~ "
			print " =========================== "
			BOX = raw_input(" Please specify the BOX CODE -> M-(2/3/4)-(B/N/W)-(1/2/3): ")
			# Bolts:
			if (BOX == "M2B1"):
				Bolts["M2Bolts1A"] = "Y"
			elif (BOX == "M2B2"):
				Bolts["M2Bolts2A"] = "Y"
			elif (BOX == "M2B3"):
				Bolts["M2Bolts3A"] = "Y"
			elif (BOX == "M3B1"):
				Bolts["M3Bolts1A"] = "Y"
			elif (BOX == "M3B2"):
				Bolts["M3Bolts2A"] = "Y"
			elif (BOX == "M3B3"):
				Bolts["M3Bolts3A"] = "Y"
			elif (BOX == "M4B1"):
				Bolts["M4Bolts1A"] = "Y"
			elif (BOX == "M4B2"):
				Bolts["M4Bolts2A"] = "Y"
			elif (BOX == "M4B3"):
				Bolts["M4Bolts3A"] = "Y"
			# Nuts:
			elif (BOX == "M2N1"):
				Nuts["M2Nuts1A"] = "Y"
			elif (BOX == "M2N2"):
				Nuts["M2Nuts2A"] = "Y"
			elif (BOX == "M2N3"):
				Nuts["M2Nuts3A"] = "Y"
			elif (BOX == "M3N1"):
				Nuts["M3Nuts1A"] = "Y"
			elif (BOX == "M3N2"):
				Nuts["M3Nuts2A"] = "Y"
			elif (BOX == "M3N3"):
				Nuts["M3Nuts3A"] = "Y"
			elif (BOX == "M4N1"):
				Nuts["M4Nuts1A"] = "Y"
			elif (BOX == "M4N2"):
				Nuts["M4Nuts2A"] = "Y"
			elif (BOX == "M4N3"):
				Nuts["M4Nuts3A"] = "Y"
			# Washers:
			elif (BOX == "M2W1"):
				Washers["M2Washers1A"] = "Y"
			elif (BOX == "M2W2"):
				Washers["M2Washers2A"] = "Y"
			elif (BOX == "M2W3"):
				Washers["M2Washers3A"] = "Y"
			elif (BOX == "M3W1"):
				Washers["M3Washers1A"] = "Y"
			elif (BOX == "M3W2"):
				Washers["M3Washers2A"] = "Y"
			elif (BOX == "M3W3"):
				Washers["M3Washers3A"] = "Y"
			elif (BOX == "M4W1"):
				Washers["M4Washers1A"] = "Y"
			elif (BOX == "M4W2"):
				Washers["M4Washers2A"] = "Y"
			elif (BOX == "M4W3"):
				Washers["M4Washers3A"] = "Y"
			else:
				print "ERROR. Incorrect BOX CODE. Please try again."

			# RE-WRITE THE MDU.txt FILE:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "w+") as file:
				file.write(str(Bolts) + "\n")
				file.write(str(Nuts) + "\n")	
				file.write(str(Washers) + "\n")
				file.close()
			print (" MDU.txt FILE HAS BEEN UPDATED SUCCESSFULLY. Added BOX: " + BOX)

		elif (OPT == "4"):

			# MDU.txt file is opened, and INFO is saved to bolts, nuts and washers dictionaries:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "r") as file:

				f = file.readlines()
		
				i = 1
				for line in f:	
					if i == 1:
						Bolts = ast.literal_eval(line)
					elif i == 2:
						Nuts = ast.literal_eval(line)
					elif i == 3:
						Washers = ast.literal_eval(line)
					else: 
						break
					i = i + 1	
		
				file.close()

			print " ~~~~~ ADDING SPARES TO A BOX ~~~~~ "
			print " ================================== "
			BOX = raw_input(" Please specify the BOX CODE -> M-(2/3/4)-(B/N/W)-(1/2/3): ")
			UNITS = int(raw_input(" Please specify the amount of spares to be added: "))
			# Bolts:
			if (BOX == "M2B1"):
				Bolts["M2Bolts1N"] = Bolts["M2Bolts1N"] + UNITS
			elif (BOX == "M2B2"):
				Bolts["M2Bolts2N"] = Bolts["M2Bolts2N"] + UNITS
			elif (BOX == "M2B3"):
				Bolts["M2Bolts3N"] = Bolts["M2Bolts3N"] + UNITS
			elif (BOX == "M3B1"):
				Bolts["M3Bolts1N"] = Bolts["M3Bolts1N"] + UNITS
			elif (BOX == "M3B2"):
				Bolts["M3Bolts2N"] = Bolts["M3Bolts2N"] + UNITS
			elif (BOX == "M3B3"):
				Bolts["M3Bolts3N"] = Bolts["M3Bolts3N"] + UNITS
			elif (BOX == "M4B1"):
				Bolts["M4Bolts1N"] = Bolts["M4Bolts1N"] + UNITS
			elif (BOX == "M4B2"):
				Bolts["M4Bolts2N"] = Bolts["M4Bolts2N"] + UNITS
			elif (BOX == "M4B3"):
				Bolts["M4Bolts3N"] = Bolts["M4Bolts3N"] + UNITS
			# Nuts:
			elif (BOX == "M2N1"):
				Nuts["M2Nuts1N"] = Nuts["M2Nuts1N"] + UNITS
			elif (BOX == "M2N2"):
				Nuts["M2Nuts2N"] = Nuts["M2Nuts2N"] + UNITS
			elif (BOX == "M2N3"):
				Nuts["M2Nuts3N"] = Nuts["M2Nuts3N"] + UNITS
			elif (BOX == "M3N1"):
				Nuts["M3Nuts1N"] = Nuts["M3Nuts1N"] + UNITS
			elif (BOX == "M3N2"):
				Nuts["M3Nuts2N"] = Nuts["M3Nuts2N"] + UNITS
			elif (BOX == "M3N3"):
				Nuts["M3Nuts3N"] = Nuts["M3Nuts3N"] + UNITS
			elif (BOX == "M4N1"):
				Nuts["M4Nuts1N"] = Nuts["M4Nuts1N"] + UNITS
			elif (BOX == "M4N2"):
				Nuts["M4Nuts2N"] = Nuts["M4Nuts2N"] + UNITS
			elif (BOX == "M4N3"):
				Nuts["M4Nuts3N"] = Nuts["M4Nuts3N"] + UNITS
			# Washers:
			elif (BOX == "M2W1"):
				Washers["M2Washers1N"] = Washers["M2Washers1N"] + UNITS
			elif (BOX == "M2W2"):
				Washers["M2Washers2N"] = Washers["M2Washers2N"] + UNITS
			elif (BOX == "M2W3"):
				Washers["M2Washers3N"] = Washers["M2Washers3N"] + UNITS
			elif (BOX == "M3W1"):
				Washers["M3Washers1N"] = Washers["M3Washers1N"] + UNITS
			elif (BOX == "M3W2"):
				Washers["M3Washers2N"] = Washers["M3Washers2N"] + UNITS
			elif (BOX == "M3W3"):
				Washers["M3Washers3N"] = Washers["M3Washers3N"] + UNITS
			elif (BOX == "M4W1"):
				Washers["M4Washers1N"] = Washers["M4Washers1N"] + UNITS
			elif (BOX == "M4W2"):
				Washers["M4Washers2N"] = Washers["M4Washers2N"] + UNITS
			elif (BOX == "M4W3"):
				Washers["M4Washers3N"] = Washers["M4Washers3N"] + UNITS
			else:
				print "ERROR. Incorrect BOX CODE. Please try again."

			# RE-WRITE THE MDU.txt FILE:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "w+") as file:
				file.write(str(Bolts) + "\n")
				file.write(str(Nuts) + "\n")	
				file.write(str(Washers) + "\n")
				file.close()
			print (" MDU.txt FILE HAS BEEN UPDATED SUCCESSFULLY. {" + str(UNITS) + "} SPARE UNITS added to BOX: " + BOX)

		elif (OPT == "5"):

			# AT.txt file is opened, and INFO is saved to AT dictionary:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "r") as file:
	
				f = file.readline()
				AT = ast.literal_eval(f)
				file.close()

			print " ~~~~~ MAKE A TRAY AVAILABLE ~~~~~ "
			print " ================================= "
			TRAY = raw_input(" Please specify the TRAY CODE -> (1/2/3): ")

			if (TRAY == "1"):
				AT["Tray1"] = "Y"
			elif (TRAY == "1N"):
				AT["Tray1"] = "N"
			elif (TRAY == "2"):
				AT["Tray2"] = "Y"
			elif (TRAY == "2N"):
				AT["Tray2"] = "N"
			elif (TRAY == "3"):
				AT["Tray3"] = "Y"
			elif (TRAY == "3N"):
				AT["Tray3"] = "N"
			else:
				print "ERROR. Incorrect TRAY CODE. Please try again."

			# RE-WRITE THE AT.txt FILE:
			with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "w+") as file:
				file.write(str(AT))
				file.close()
			print ("- AT.txt FILE HAS BEEN UPDATED SUCCESSFULLY. Added TRAY: Tray" + str(TRAY))

		elif (OPT == "0"):
			print "CLOSING PROGRAM... bye!"
			EXIT = True

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

