#!/usr/bin/env python

# STEP NUMBER 2 (Material Storage Module):
# We check the availability of the materials in the MDU, and we return the slot:

import sys
import rospy
import roslib
import message_filters
import ast

if __name__ == '__main__':
    try:
	
	rospy.init_node("AKS_Step2_rack", log_level = rospy.INFO)

	print "STEP NUMBER 2"
	print "=============" 
	print "THE AVAILABILITY OF THE MATERIALS IN THE MDU WILL BE CHECKED:"
	print "-------------------------------------------------------------"

	# MDU.txt file is opened, and INFO is saved to bolts, nuts and washers dictionaries:

	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "r") as file:

		f = file.readlines()
		
		i = 1
		for line in f:	
			if i == 1:
				Bolts = ast.literal_eval(line)
			elif i == 2:
				Nuts = ast.literal_eval(line)
			elif i == 3:
				Washers = ast.literal_eval(line)
			else: 
				break
			i = i + 1	
		
		file.close()

	# THE MATERIAL LIST file is opened, and material requests are saved to variables:

	code = raw_input("Please specify the Material List CODE: ")
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + ".txt", "r") as file:

		f = file.readline()
		ML = ast.literal_eval(f)
		
		# Material List components --> Variables
		m2Bolts = ML["M2Bolts"]
		m3Bolts = ML["M3Bolts"]
		m4Bolts = ML["M4Bolts"]
		m2Nuts = ML["M2Nuts"]
		m3Nuts = ML["M3Nuts"]
		m4Nuts = ML["M4Nuts"]
		m2Washers = ML["M2Washers"]
		m3Washers = ML["M3Washers"]
		m4Washers = ML["M4Washers"]

		file.close()
	
	print "-------------------------------------------------------------"
	print "CHECKING AVAILABILITY..."
	#rospy.sleep(1)

	warning = 0
	dictionary = {}
	
	# BOLTS CHECK:
	if (m2Bolts != 0):
		print ("M2 Bolts --> In MDU: BOX1->" + str(Bolts["M2Bolts1N"]) + ", BOX2->" + str(Bolts["M2Bolts2N"]) + ", BOX3->" + str(Bolts["M2Bolts3N"]) + ", in ML: " + str(m2Bolts))
		if (Bolts["M2Bolts1N"] >= m2Bolts) and (Bolts["M2Bolts1A"] == "Y"):
			print ("M2 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M2Bolts1S"]))
			dictionary.update({"M2BoltsR":Bolts["M2Bolts1S"]})
		elif (Bolts["M2Bolts2N"] >= m2Bolts) and (Bolts["M2Bolts2A"] == "Y"):
			print ("M2 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M2Bolts2S"]))
			dictionary.update({"M2BoltsR":Bolts["M2Bolts2S"]})
		elif (Bolts["M2Bolts3N"] >= m2Bolts) and (Bolts["M2Bolts3A"] == "Y"):
			print ("M2 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M2Bolts3S"]))
			dictionary.update({"M2BoltsR":Bolts["M2Bolts3S"]})
		else:
			print ("M2 Bolts NOT AVAILABLE in MDU.")
			warning = 1
	if (m3Bolts != 0):
		print ("M3 Bolts --> In MDU: BOX1->" + str(Bolts["M3Bolts1N"]) + ", BOX2->" + str(Bolts["M3Bolts2N"]) + ", BOX3->" + str(Bolts["M3Bolts3N"]) + ", in ML: " + str(m3Bolts))
		if (Bolts["M2Bolts1N"] >= m3Bolts) and (Bolts["M3Bolts1A"] == "Y"):
			print ("M3 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M3Bolts1S"]))
			dictionary.update({"M3BoltsR":Bolts["M3Bolts1S"]})
		elif (Bolts["M3Bolts2N"] >= m3Bolts) and (Bolts["M3Bolts2A"] == "Y"):
			print ("M3 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M3Bolts2S"]))
			dictionary.update({"M3BoltsR":Bolts["M3Bolts2S"]})
		elif (Bolts["M3Bolts3N"] >= m3Bolts) and (Bolts["M3Bolts3A"] == "Y"):
			print ("M3 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M3Bolts3S"]))
			dictionary.update({"M3BoltsR":Bolts["M3Bolts3S"]})
		else:
			print ("M3 Bolts NOT AVAILABLE in MDU.")
			warning = 1
	if (m4Bolts != 0):
		print ("M4 Bolts --> In MDU: BOX1->" + str(Bolts["M4Bolts1N"]) + ", BOX2->" + str(Bolts["M4Bolts2N"]) + ", BOX3->" + str(Bolts["M4Bolts3N"]) + ", in ML: " + str(m4Bolts))
		if (Bolts["M4Bolts1N"] >= m4Bolts) and (Bolts["M4Bolts1A"] == "Y"):
			print ("M4 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M4Bolts1S"]))
			dictionary.update({"M4BoltsR":Bolts["M4Bolts1S"]})
		elif (Bolts["M4Bolts2N"] >= m4Bolts) and (Bolts["M4Bolts2A"] == "Y"):
			print ("M4 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M4Bolts2S"]))
			dictionary.update({"M4BoltsR":Bolts["M4Bolts2S"]})
		elif (Bolts["M4Bolts3N"] >= m4Bolts) and (Bolts["M4Bolts3A"] == "Y"):
			print ("M4 Bolts AVAILABLE in MDU: SLOT NUMBER " + str(Bolts["M4Bolts3S"]))
			dictionary.update({"M4BoltsR":Bolts["M4Bolts3S"]})
		else:
			print ("M4 Bolts NOT AVAILABLE in MDU.")
			warning = 1

	# NUTS CHECK:
	if (m2Nuts != 0):
		print ("M2 Nuts --> In MDU: BOX1->" + str(Nuts["M2Nuts1N"]) + ", BOX2->" + str(Nuts["M2Nuts2N"]) + ", BOX3->" + str(Nuts["M2Nuts3N"]) + ", in ML: " + str(m2Nuts))
		if (Nuts["M2Nuts1N"] >= m2Nuts) and (Nuts["M2Nuts1A"] == "Y"):
			print ("M2 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M2Nuts1S"]))
			dictionary.update({"M2NutsR":Nuts["M2Nuts1S"]})
		elif (Nuts["M2Nuts2N"] >= m2Nuts) and (Nuts["M2Nuts2A"] == "Y"):
			print ("M2 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M2Nuts2S"]))
			dictionary.update({"M2NutsR":Nuts["M2Nuts2S"]})
		elif (Nuts["M2Nuts3N"] >= m2Nuts) and (Nuts["M2Nuts3A"] == "Y"):
			print ("M2 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M2Nuts3S"]))
			dictionary.update({"M2NutsR":Nuts["M2Nuts3S"]})
		else:
			print ("M2 Nuts NOT AVAILABLE in MDU.")
			warning = 1
	if (m3Nuts != 0):
		print ("M3 Nuts --> In MDU: BOX1->" + str(Nuts["M3Nuts1N"]) + ", BOX2->" + str(Nuts["M3Nuts2N"]) + ", BOX3->" + str(Nuts["M3Nuts3N"]) + ", in ML: " + str(m3Nuts))
		if (Nuts["M3Nuts1N"] >= m3Nuts) and (Nuts["M3Nuts1A"] == "Y"):
			print ("M3 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M3Nuts1S"]))
			dictionary.update({"M3NutsR":Nuts["M3Nuts1S"]})
		elif (Nuts["M3Nuts2N"] >= m3Nuts) and (Nuts["M3Nuts2A"] == "Y"):
			print ("M3 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M3Nuts2S"]))
			dictionary.update({"M3NutsR":Nuts["M3Nuts2S"]})
		elif (Nuts["M3Nuts3N"] >= m3Nuts) and (Nuts["M3Nuts3A"] == "Y"):
			print ("M3 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M3Nuts3S"]))
			dictionary.update({"M3NutsR":Nuts["M3Nuts3S"]})
		else:
			print ("M3 Nuts NOT AVAILABLE in MDU.")
			warning = 1
	if (m4Nuts != 0):
		print ("M4 Nuts --> In MDU: BOX1->" + str(Nuts["M4Nuts1N"]) + ", BOX2->" + str(Nuts["M4Nuts2N"]) + ", BOX3->" + str(Nuts["M4Nuts3N"]) + ", in ML: " + str(m4Nuts))
		if (Nuts["M4Nuts1N"] >= m4Nuts) and (Nuts["M4Nuts1A"] == "Y"):
			print ("M4 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M4Nuts1S"]))
			dictionary.update({"M4NutsR":Nuts["M4Nuts1S"]})
		elif (Nuts["M4Nuts2N"] >= m4Nuts) and (Nuts["M4Nuts2A"] == "Y"):
			print ("M4 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M4Nuts2S"]))
			dictionary.update({"M4NutsR":Nuts["M4Nuts2S"]})
		elif (Nuts["M4Nuts3N"] >= m4Nuts) and (Nuts["M4Nuts3A"] == "Y"):
			print ("M4 Nuts AVAILABLE in MDU: SLOT NUMBER " + str(Nuts["M4Nuts3S"]))
			dictionary.update({"M4NutsR":Nuts["M4Nuts3S"]})
		else:
			print ("M4 Nuts NOT AVAILABLE in MDU.")
			warning = 1

	# WASHERS CHECK:
	if (m2Washers != 0):
		print ("M2 Washers --> In MDU: BOX1->" + str(Washers["M2Washers1N"]) + ", BOX2->" + str(Washers["M2Washers2N"]) + ", BOX3->" + str(Washers["M2Washers3N"]) + ", in ML: " + str(m2Washers))
		if (Washers["M2Washers1N"] >= m2Washers) and (Washers["M2Washers1A"] == "Y"):
			print ("M2 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M2Washers1S"]))
			dictionary.update({"M2WashersR":Washers["M2Washers1S"]})
		elif (Washers["M2Washers2N"] >= m2Washers) and (Washers["M2Washers2A"] == "Y"):
			print ("M2 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M2Washers2S"]))
			dictionary.update({"M2WashersR":Washers["M2Washers2S"]})
		elif (Washers["M2Washers3N"] >= m2Washers) and (Washers["M2Washers3A"] == "Y"):
			print ("M2 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M2Washers3S"]))
			dictionary.update({"M2WashersR":Washers["M2Washers3S"]})
		else:
			print ("M2 Washers NOT AVAILABLE in MDU.")
			warning = 1
	if (m3Washers != 0):
		print ("M3 Washers --> In MDU: BOX1->" + str(Washers["M3Washers1N"]) + ", BOX2->" + str(Washers["M3Washers2N"]) + ", BOX3->" + str(Washers["M3Washers3N"]) + ", in ML: " + str(m3Washers))
		if (Washers["M2Washers1N"] >= m3Washers) and (Washers["M3Washers1A"] == "Y"):
			print ("M3 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M3Washers1S"]))
			dictionary.update({"M3WashersR":Washers["M3Washers1S"]})
		elif (Washers["M3Washers2N"] >= m3Washers) and (Washers["M3Washers2A"] == "Y"):
			print ("M3 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M3Washers2S"]))
			dictionary.update({"M3WashersR":Washers["M3Washers2S"]})
		elif (Washers["M3Washers3N"] >= m3Washers) and (Washers["M3Washers3A"] == "Y"):
			print ("M3 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M3Washers3S"]))
			dictionary.update({"M3WashersR":Washers["M3Washers3S"]})
		else:
			print ("M3 Washers NOT AVAILABLE in MDU.")
			warning = 1
	if (m4Washers != 0):
		print ("M4 Washers --> In MDU: BOX1->" + str(Washers["M4Washers1N"]) + ", BOX2->" + str(Washers["M4Washers2N"]) + ", BOX3->" + str(Washers["M4Washers3N"]) + ", in ML: " + str(m4Washers))
		if (Washers["M4Washers1N"] >= m4Washers) and (Washers["M4Washers1A"] == "Y"):
			print ("M4 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M4Washers1S"]))
			dictionary.update({"M4WashersR":Washers["M4Washers1S"]})
		elif (Washers["M4Washers2N"] >= m4Washers) and (Washers["M4Washers2A"] == "Y"):
			print ("M4 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M4Washers2S"]))
			dictionary.update({"M4WashersR":Washers["M4Washers2S"]})
		elif (Washers["M4Washers3N"] >= m4Washers) and (Washers["M4Washers3A"] == "Y"):
			print ("M4 Washers AVAILABLE in MDU: SLOT NUMBER " + str(Washers["M4Washers3S"]))
			dictionary.update({"M4WashersR":Washers["M4Washers3S"]})
		else:
			print ("M4 Washers NOT AVAILABLE in MDU.")
			warning = 1
		

	# IF MATERIAL AVAILABLE, a new "code"_rack.txt file will be created:
	print "-------------------------------------------------------------"
	if (warning == 0):
		with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_rack.txt", "w+") as file:
			file.write(str(dictionary))
		print (code + "_rack.txt file created with the MDU SLOTS of each MATERIAL in ML")
	else:
		print "ML CANNOT BE PROCESSED DUE TO MATERIAL UNAVAILABILITY."
	

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

