#!/usr/bin/env python

# STEP NUMBER 2 (Kitting Module):
# We assign the ASSORTMENT TRAY size according to the ML:

import sys
import rospy
import roslib
import message_filters
import ast

if __name__ == '__main__':
    try:
	
	rospy.init_node("AKS_Step2_tray", log_level = rospy.INFO)

	print "STEP NUMBER 2"
	print "=============" 
	print "THE ASSORTMENT TRAY WILL BE ASSIGNED:"
	print "------------------------------------------"

	# AVAILABLE TRAYS:
	# 4-Slot Tray - 6-Slot Tray - 9-Slot Tray
	# MAIN ASSUMPTION: ALL 3 TRAYS ARE AVAILABLE ALL THE TIME FOR KITTING.
	# ANOTHER ASSUMPTION: Since all boxes have the same size, all slots in trays have the same dimensions.

	# AVAILABLE TRAYS:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "r") as file:

		f = file.readline()
		tray = ast.literal_eval(f)
		file.close()
	
	print("Availability:")
	if (tray["Tray1"] == "Y"):
		print(" - Tray 1: AVAILABLE")
	else:
		print(" - Tray 1: NOT AVAILABLE")
	if (tray["Tray2"] == "Y"):
		print(" - Tray 2: AVAILABLE")
	else:
		print(" - Tray 2: NOT AVAILABLE")
	if (tray["Tray3"] == "Y"):
		print(" - Tray 3: AVAILABLE")
	else:
		print(" - Tray 3: NOT AVAILABLE")

	# THE MATERIAL LIST file is opened, and material requests are saved to variables:
	print "------------------------------------------"
	code = raw_input("Please specify the Material List CODE: ")
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + ".txt", "r") as file:

		f = file.readline()
		ML = ast.literal_eval(f)
		
		# Material List components --> Variables
		m2Bolts = ML["M2Bolts"]
		m3Bolts = ML["M3Bolts"]
		m4Bolts = ML["M4Bolts"]
		m2Nuts = ML["M2Nuts"]
		m3Nuts = ML["M3Nuts"]
		m4Nuts = ML["M4Nuts"]
		m2Washers = ML["M2Washers"]
		m3Washers = ML["M3Washers"]
		m4Washers = ML["M4Washers"]

		file.close()
	
	print "------------------------------------------"
	print "ASSIGNING ASSORTMENT TRAY..."
	#rospy.sleep(1)

	# WE CALCULATE THE SIZE:
	dictionary = {}
	i = 1
	# BOLTS CHECK:
	if (m2Bolts != 0):
		dictionary.update({"M2BoltsT":i})
		i = i + 1
	if (m3Bolts != 0):
		dictionary.update({"M3BoltsT":i})
		i = i + 1
	if (m4Bolts != 0):
		dictionary.update({"M4BoltsT":i})
		i = i + 1

	# NUTS CHECK:
	if (m2Nuts != 0):
		dictionary.update({"M2NutsT":i})
		i = i + 1
	if (m3Nuts != 0):
		dictionary.update({"M3NutsT":i})
		i = i + 1
	if (m4Nuts != 0):
		dictionary.update({"M4NutsT":i})
		i = i + 1

	# WASHERS CHECK:
	if (m2Washers != 0):
		dictionary.update({"M2WashersT":i})
		i = i + 1
	if (m3Washers != 0):
		dictionary.update({"M3WashersT":i})
		i = i + 1
	if (m4Washers != 0):
		dictionary.update({"M4WashersT":i})
		i = i + 1

	size = len(dictionary)

	# TRAY SIZE will be assigned:
	if (size == 0):
		print "ERROR. No objects in the KIT."
	elif (size >= 1 and size <= 4 ):
		print ("The number of objects in the KIT is: " + str(size))
		if (tray["Tray1"] == "Y"):
			print ("The ASSORTMENT TRAY of 4 SLOTS has been assigned.")
			var = 1
		elif (tray["Tray2"] == "Y"):
			print ("The ASSORTMENT TRAY of 6 SLOTS has been assigned.")
			var = 2
		elif (tray["Tray3"] == "Y"):
			print ("The ASSORTMENT TRAY of 9 SLOTS has been assigned.")
			var = 3
		else:
			print ("ERROR. There are no trays available for the amount of materials required.")
	elif (size == 5 or size == 6 ):
		print ("The number of objects in the KIT is: " + str(size))
		if (tray["Tray2"] == "Y"):
			print ("The ASSORTMENT TRAY of 6 SLOTS has been assigned.")
			var = 2
		elif (tray["Tray3"] == "Y"):
			print ("The ASSORTMENT TRAY of 9 SLOTS has been assigned.")
			var = 3
		else:
			print ("ERROR. There are no trays available for the amount of materials required.")
	elif (size >= 7 or size <= 9 ):
		print ("The number of objects in the KIT is: " + str(size))
		if (tray["Tray3"] == "Y"):
			print ("The ASSORTMENT TRAY of 9 SLOTS has been assigned.")
			var = 3
		else:
			print ("ERROR. There are no trays available for the amount of materials required.")
	elif (size >= 10):
		print ("ERROR. The number of objects in the KIT is more than the maximum (9).")

	# OUTPUT DICTIONARY:
	outdict = {}
	i = 1
	if (m2Bolts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M2BoltsT":out})
		i = i + 1
	if (m3Bolts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M3BoltsT":out})
		i = i + 1
	if (m4Bolts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M4BoltsT":out})
		i = i + 1
	if (m2Nuts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M2NutsT":out})
		i = i + 1
	if (m3Nuts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M3NutsT":out})
		i = i + 1
	if (m4Nuts != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M4NutsT":out})
		i = i + 1
	if (m2Washers != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M2WashersT":out})
		i = i + 1
	if (m3Washers != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M3WashersT":out})
		i = i + 1
	if (m4Washers != 0):
		out = float((str(var) + "." +str(i)))
		outdict.update({"M4WashersT":out})
		i = i + 1

	# A new "code"_tray.txt file will be created:
	print "------------------------------------------"
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_tray.txt", "w+") as file:
		file.write(str(outdict))
	print (code + "_tray.txt file created with the ASSORTMENT TRAY and SLOTS assigned for the ML.")

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

