#!/usr/bin/env python

# STEP NUMBER 3:
# The "code_tray.txt" and "code_rack.txt" files for the ML will be opened, and the information 
# of both the slots in the MDU and the ASSORTMENT TRAY will be sent to the ROBOT:

import sys
import rospy
import roslib
import message_filters
import ast
import rospy
import actionlib
import tf
import time
from rospy_message_converter import message_converter
from std_msgs.msg import String
from aks_gazebo.msg import trajectories as trajectories

global request
# Define the publisher: DATA -> ROBOT
pub = rospy.Publisher('data_robot', trajectories, queue_size=1)	
					        
def callback_str(data):
	
	global code
	request = str(data.data)
	#rospy.loginfo("Message subscribed: Request -> " + request)
	
	if (request == "next"):
		print "----------------------------------------------------------------------"
		print("AUTOMATED KITTING of the ML " + code + " has finished.")
		print("You can now KILL this execution.")
	exit()

def subscriber():
	rospy.Subscriber("robot_data", String, callback_str)	
	rospy.spin()

if __name__ == '__main__':
    try:
	
	rospy.init_node("AKS_Step3", log_level = rospy.INFO)

	print "STEP NUMBER 3"
	print "=============" 
	print "The SLOT information will be sent to the ROBOT, for posterior KITTING:"
	print "----------------------------------------------------------------------"

	# _rack.txt and _tray.txt files are opened, and INFO is saved to "tray" and "rack" dictionaries:

	code = raw_input("Please specify the Material List CODE: ")
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_rack.txt", "r") as file:

		f = file.readline()
		rack = ast.literal_eval(f)
		file.close()

	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_tray.txt", "r") as file:

		f = file.readline()
		tray = ast.literal_eval(f)
		file.close()

	# ====================================================================================================== #
	
	dictionary = {}
	# We will create a dictionary of dictionaries:

	# 1. Step -> Open the ML file, and save values to variables:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + ".txt", "r") as file:

		f = file.readline()
		ML = ast.literal_eval(f)
		
		# Material List components --> Variables
		m2Bolts = ML["M2Bolts"]
		m3Bolts = ML["M3Bolts"]
		m4Bolts = ML["M4Bolts"]
		m2Nuts = ML["M2Nuts"]
		m3Nuts = ML["M3Nuts"]
		m4Nuts = ML["M4Nuts"]
		m2Washers = ML["M2Washers"]
		m3Washers = ML["M3Washers"]
		m4Washers = ML["M4Washers"]

		file.close()

	# 2. Step -> Check material, and add values to dictionary:
	i = 1
	# BOLTS:
	if (m2Bolts != 0):
		A = rack["M2BoltsR"]
		B = tray["M2BoltsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m3Bolts != 0):
		A = rack["M3BoltsR"]
		B = tray["M3BoltsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m4Bolts != 0):
		A = rack["M4BoltsR"]
		B = tray["M4BoltsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	# NUTS:
	if (m2Nuts != 0):
		A = rack["M2NutsR"]
		B = tray["M2NutsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m3Nuts != 0):
		A = rack["M3NutsR"]
		B = tray["M3NutsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m4Nuts != 0):
		A = rack["M4NutsR"]
		B = tray["M4NutsT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	# WASHERS:
	if (m2Washers != 0):
		A = rack["M2WashersR"]
		B = tray["M2WashersT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m3Washers != 0):
		A = rack["M3WashersR"]
		B = tray["M3WashersT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})
		i = i + 1
	if (m4Washers != 0):
		A = rack["M4WashersR"]
		B = tray["M4WashersT"]
		C = {"R": A, "T": B}
		dictionary.update({str(i): C})

	# ====================================================================================================== #
	
	# We have to send (PUBLISH) the dictionary with the data:
	msg = trajectories()
	size = len(dictionary)

	for x in range(1,size+1):
		msg.rack.append(dictionary[str(x)]["R"])
		msg.tray.append(dictionary[str(x)]["T"])
	
	# ASSIGN VALUES!
	print ("SLOTS IN MDU: " + str(msg.rack))
	print ("SLOTS IN AT: " + str(msg.tray))
		
	pub.publish(msg)
	print ("SUCCESS! Message published to the robot with rack[] and tray[] WAYPOINTS.")

	subscriber()

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

