#!/usr/bin/env python

# STEP NUMBER 4:
# After undertaking a KITTING PROCESS of an specific ML, MDU and AT .txt files will be updated.

import sys
import rospy
import roslib
import message_filters
import ast

if __name__ == '__main__':
    try:
	
	rospy.init_node("AKS_Step4", log_level = rospy.INFO)

	print "STEP NUMBER 4"
	print "=============" 
	print "The MDU.txt and AT.txt files will be updated."
	print "----------------------------------------------------------------------"

	# MDU.txt file is opened, and INFO is saved to bolts, nuts and washers dictionaries:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "r") as file:

		f = file.readlines()
		
		i = 1
		for line in f:	
			if i == 1:
				Bolts = ast.literal_eval(line)
			elif i == 2:
				Nuts = ast.literal_eval(line)
			elif i == 3:
				Washers = ast.literal_eval(line)
			else: 
				break
			i = i + 1	
		
		file.close()
	
	# AT.txt file is opened, and INFO is saved to AT dictionary:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "r") as file:
	
		f = file.readline()
		AT = ast.literal_eval(f)
		file.close()

	# _rack.txt and _tray.txt files are opened, and INFO is saved to "tray" and "rack" dictionaries:
	code = raw_input("Please specify the Material List CODE: ")
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_rack.txt", "r") as file:

		f = file.readline()
		rack = ast.literal_eval(f)
		file.close()

	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + "_tray.txt", "r") as file:

		f = file.readline()
		tray = ast.literal_eval(f)
		file.close()

	size = len(rack)

	# THE MATERIAL LIST file is opened, and material requests are saved to variables:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/" + code + ".txt", "r") as file:

		f = file.readline()
		ML = ast.literal_eval(f)
		
		# Material List components --> Variables
		m2Bolts = ML["M2Bolts"]
		m3Bolts = ML["M3Bolts"]
		m4Bolts = ML["M4Bolts"]
		m2Nuts = ML["M2Nuts"]
		m3Nuts = ML["M3Nuts"]
		m4Nuts = ML["M4Nuts"]
		m2Washers = ML["M2Washers"]
		m3Washers = ML["M3Washers"]
		m4Washers = ML["M4Washers"]

		file.close()


	# ====================================================================================================== #

	# 1. Step -> UPDATE THE MDU.txt FILE:
	
	# BOLTS:	
	if (m2Bolts != 0):
		if (rack["M2BoltsR"] == 3.1):
			Bolts["M2Bolts1N"] = Bolts["M2Bolts1N"] - m2Bolts
			Bolts["M2Bolts1A"] = "N"
		elif (rack["M2BoltsR"] == 3.2):
			Bolts["M2Bolts2N"] = Bolts["M2Bolts2N"] - m2Bolts
			Bolts["M2Bolts2A"] = "N"
		elif (rack["M2BoltsR"] == 3.3):
			Bolts["M2Bolts3N"] = Bolts["M2Bolts3N"] - m2Bolts
			Bolts["M2Bolts3A"] = "N"
	if (m3Bolts != 0):
		if (rack["M3BoltsR"] == 3.4):
			Bolts["M3Bolts1N"] = Bolts["M3Bolts1N"] - m3Bolts
			Bolts["M3Bolts1A"] = "N"
		elif (rack["M3BoltsR"] == 3.5):
			Bolts["M3Bolts2N"] = Bolts["M3Bolts2N"] - m3Bolts
			Bolts["M3Bolts2A"] = "N"
		elif (rack["M3BoltsR"] == 3.6):
			Bolts["M3Bolts3N"] = Bolts["M3Bolts3N"] - m3Bolts
			Bolts["M3Bolts3A"] = "N"
	if (m4Bolts != 0):
		if (rack["M4BoltsR"] == 3.7):
			Bolts["M4Bolts1N"] = Bolts["M4Bolts1N"] - m4Bolts
			Bolts["M4Bolts1A"] = "N"
		elif (rack["M4BoltsR"] == 3.8):
			Bolts["M4Bolts2N"] = Bolts["M4Bolts2N"] - m4Bolts
			Bolts["M4Bolts2A"] = "N"
		elif (rack["M4BoltsR"] == 3.9):
			Bolts["M4Bolts3N"] = Bolts["M4Bolts3N"] - m4Bolts
			Bolts["M4Bolts3A"] = "N"
	# NUTS:
	if (m2Nuts != 0):
		if (rack["M2NutsR"] == 2.1):
			Nuts["M2Nuts1N"] = Nuts["M2Nuts1N"] - m2Nuts
			Nuts["M2Nuts1A"] = "N"
		elif (rack["M2NutsR"] == 2.2):
			Nuts["M2Nuts2N"] = Nuts["M2Nuts2N"] - m2Nuts
			Nuts["M2Nuts2A"] = "N"
		elif (rack["M2NutsR"] == 2.3):
			Nuts["M2Nuts3N"] = Nuts["M2Nuts3N"] - m2Nuts
			Nuts["M2Nuts3A"] = "N"
	if (m3Nuts != 0):
		if (rack["M3NutsR"] == 2.4):
			Nuts["M3Nuts1N"] = Nuts["M3Nuts1N"] - m3Nuts
			Nuts["M3Nuts1A"] = "N"
		elif (rack["M3NutsR"] == 2.5):
			Nuts["M3Nuts2N"] = Nuts["M3Nuts2N"] - m3Nuts
			Nuts["M3Nuts2A"] = "N"
		elif (rack["M3NutsR"] == 2.6):
			Nuts["M3Nuts3N"] = Nuts["M3Nuts3N"] - m3Nuts
			Nuts["M3Nuts3A"] = "N"
	if (m4Nuts != 0):
		if (rack["M4NutsR"] == 2.7):
			Nuts["M4Nuts1N"] = Nuts["M4Nuts1N"] - m4Nuts
			Nuts["M4Nuts1A"] = "N"
		elif (rack["M4NutsR"] == 2.8):
			Nuts["M4Nuts2N"] = Nuts["M4Nuts2N"] - m4Nuts
			Nuts["M4Nuts2A"] = "N"
		elif (rack["M4NutsR"] == 2.9):
			Nuts["M4Nuts3N"] = Nuts["M4Nuts3N"] - m4Nuts
			Nuts["M4Nuts3A"] = "N"

	# WASHERS:
	if (m2Washers != 0):
		if (rack["M2WashersR"] == 1.1):
			Washers["M2Washers1N"] = Washers["M2Washers1N"] - m2Washers
			Washers["M2Washers1A"] = "N"
		elif (rack["M2WashersR"] == 1.2):
			Washers["M2Washers2N"] = Washers["M2Washers2N"] - m2Washers
			Washers["M2Washers2A"] = "N"
		elif (rack["M2WashersR"] == 1.3):
			Washers["M2Washers3N"] = Washers["M2Washers3N"] - m2Washers
			Washers["M2Washers3A"] = "N"
	if (m3Washers != 0):
		if (rack["M3WashersR"] == 1.4):
			Washers["M3Washers1N"] = Washers["M3Washers1N"] - m3Washers
			Washers["M3Washers1A"] = "N"
		elif (rack["M3WashersR"] == 1.5):
			Washers["M3Washers2N"] = Washers["M3Washers2N"] - m3Washers
			Washers["M3Washers2A"] = "N"
		elif (rack["M3WashersR"] == 1.6):
			Washers["M3Washers3N"] = Washers["M3Washers3N"] - m3Washers
			Washers["M3Washers3A"] = "N"
	if (m4Washers != 0):
		if (rack["M4WashersR"] == 1.7):
			Washers["M4Washers1N"] = Washers["M4Washers1N"] - m4Washers
			Washers["M4Washers1A"] = "N"
		elif (rack["M4WashersR"] == 1.8):
			Washers["M4Washers2N"] = Washers["M4Washers2N"] - m4Washers
			Washers["M4Washers2A"] = "N"
		elif (rack["M4WashersR"] == 1.9):
			Washers["M4Washers3N"] = Washers["M4Washers3N"] - m4Washers
			Washers["M4Washers3A"] = "N"

	# RE-WRITE THE MDU.txt FILE:
	print "-------------------------------------------------------------"
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/MDU.txt", "w+") as file:
		file.write(str(Bolts) + "\n")
		file.write(str(Nuts) + "\n")	
		file.write(str(Washers) + "\n")
		file.close()
	print ("- MDU.txt FILE HAS BEEN UPDATED SUCCESSFULLY. Updated ML: " + code)

	# ====================================================================================================== #

	# 2. Step -> UPDATE THE AT.txt FILE:
	# BOLTS:	
	if (m2Bolts != 0):
		if (tray["M2BoltsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M2BoltsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m3Bolts != 0):
		if (tray["M3BoltsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M3BoltsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m4Bolts != 0):
		if (tray["M4BoltsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M4BoltsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	# NUTS:
	if (m2Nuts != 0):
		if (tray["M2NutsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M2NutsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m3Nuts != 0):
		if (tray["M3NutsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M3NutsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m4Nuts != 0):
		if (tray["M4NutsT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M4NutsT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"

	# WASHERS:
	if (m2Washers != 0):
		if (tray["M2WashersT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M2WashersT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m3Washers != 0):
		if (tray["M3WashersT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M3WashersT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	if (m4Washers != 0):
		if (tray["M4WashersT"] < 2):
			AT["Tray1"] = "N"
		elif (tray["M4WashersT"] > 3):
			AT["Tray3"] = "N"
		else:
		 	AT["Tray2"] = "N"
	
	# RE-WRITE THE AT.txt FILE:
	with open("/home/mikelbueno/catkin_ws/src/aks_gazebo/scripts/aks/AT.txt", "w+") as file:
		file.write(str(AT))
		file.close()
	print ("- AT.txt FILE HAS BEEN UPDATED SUCCESSFULLY. Updated ML: " + code)

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

