#!/usr/bin/env python

# CONTROL OF THE GRIPPER:

import sys
import copy
import rospy
import moveit_commander
import moveit_msgs.msg
import geometry_msgs.msg
import control_msgs.msg
import actionlib
import tf
from math import pi
from std_msgs.msg import String
from moveit_commander.conversions import pose_to_list

global gripper_data
gripper_previous = "open"

def callback_str(data):

	global gripper_previous

	gripper_data = str(data.data)
	#rospy.loginfo("Message subscribed: Gripper -> " + gripper_data)

	if (gripper_data != gripper_previous):
		# GRIPPER OPEN/CLOSE ACTION:
		if (gripper_data == "open"):
			print "OPENING GRIPPER"
			gripper_goal = move_gripper.get_current_joint_values()
			gripper_goal[2] = 0.00
			move_gripper.go(gripper_goal, wait=True)
			gripper_previous = "open"	
		elif (gripper_data == "close"):	
			print "CLOSING GRIPPER"
			gripper_goal = move_gripper.get_current_joint_values()
			gripper_goal[2] = 0.39
			move_gripper.go(gripper_goal, wait=True)
			gripper_previous = "close"
		else:
			gripper_previous = gripper_previous	

def subscriber():
	rospy.Subscriber("robot_data", String, callback_str)	
	rospy.spin()

if __name__ == '__main__':
    try:

        # We initialize the node:
	rospy.init_node('gripper_control', anonymous=True)
        
	# We initialize moveit_commander, and robot, scene and gripper groups:
	moveit_commander.roscpp_initialize(sys.argv)
	robot = moveit_commander.RobotCommander() 
	scene = moveit_commander.PlanningSceneInterface()
 	gripper_name="gripper"
	move_gripper = moveit_commander.MoveGroupCommander(gripper_name)

	#gripper_previous = "open"
	subscriber()

    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

