#!/usr/bin/env python

# UR5 PICK & PLACE. PYTHON SCRIPT

import sys
import copy
import rospy
import moveit_commander
import moveit_msgs.msg
import geometry_msgs.msg
import control_msgs.msg
import actionlib
import tf
import time
from math import pi
from std_msgs.msg import String
from aks_gazebo.msg import trajectories as trajectories
from moveit_commander.conversions import pose_to_list

CONV = pi/180
msg = trajectories()
msg.rack = []
msg.tray = []

pub = rospy.Publisher("robot_data", String, queue_size=1)

def publisher(action):
    publ = rospy.Publisher('robot_data', String, queue_size=1)
    rate = rospy.Rate(10)	                                     
    publ.publish(action)	                                        
    rate.sleep()					        

				        
def callback_msg(data):
	global msg

	msg = data
	size = len(msg.rack)

	# PATH PLANNING:
	for i in range(0,size):
			
		# Pick:
		if (msg.rack[i] == 3.1):
			Pick_31()
		elif (msg.rack[i] == 3.2):
			Pick_32()
		elif (msg.rack[i] == 3.3):
			Pick_33()
		elif (msg.rack[i] == 3.4):
			Pick_34()
		elif (msg.rack[i] == 3.5):
			Pick_35()
		elif (msg.rack[i] == 3.6):
			Pick_36()
		elif (msg.rack[i] == 3.7):
			Pick_37()
		elif (msg.rack[i] == 3.8):
			Pick_38()
		elif (msg.rack[i] == 3.9):
			Pick_39()
		elif (msg.rack[i] == 2.1):
			Pick_21()
		elif (msg.rack[i] == 2.2):
			Pick_22()
		elif (msg.rack[i] == 2.3):
			Pick_23()
		elif (msg.rack[i] == 2.4):
			Pick_24()
		elif (msg.rack[i] == 2.5):
			Pick_25()
		elif (msg.rack[i] == 2.6):
			Pick_26()
		elif (msg.rack[i] == 2.7):
			Pick_27()
		elif (msg.rack[i] == 2.8):
			Pick_28()
		elif (msg.rack[i] == 2.9):
			Pick_29()
		elif (msg.rack[i] == 1.1):
			Pick_11()
		elif (msg.rack[i] == 1.2):
			Pick_12()
		elif (msg.rack[i] == 1.3):
			Pick_13()
		elif (msg.rack[i] == 1.4):
			Pick_14()
		elif (msg.rack[i] == 1.5):
			Pick_15()
		elif (msg.rack[i] == 1.6):
			Pick_16()
		elif (msg.rack[i] == 1.7):
			Pick_17()
		elif (msg.rack[i] == 1.8):
			Pick_18()
		elif (msg.rack[i] == 1.9):
			Pick_19()
		
		# Place:
		if (msg.tray[i] == 1.1):
			Place_11()
		elif (msg.tray[i] == 1.2):
			Place_12()
		elif (msg.tray[i] == 1.3):
			Place_13()
		elif (msg.tray[i] == 1.4):
			Place_14()
		elif (msg.tray[i] == 2.1):
			Place_21()
		elif (msg.tray[i] == 2.2):
			Place_22()
		elif (msg.tray[i] == 2.3):
			Place_23()
		elif (msg.tray[i] == 2.4):
			Place_24()
		elif (msg.tray[i] == 2.5):
			Place_25()
		elif (msg.tray[i] == 2.6):
			Place_26()
		elif (msg.tray[i] == 3.1):
			Place_31()
		elif (msg.tray[i] == 3.2):
			Place_32()
		elif (msg.tray[i] == 3.3):
			Place_33()
		elif (msg.tray[i] == 3.4):
			Place_34()
		elif (msg.tray[i] == 3.5):
			Place_35()
		elif (msg.tray[i] == 3.6):
			Place_36()
		elif (msg.tray[i] == 3.7):
			Place_37()
		elif (msg.tray[i] == 3.8):
			Place_38()
		elif (msg.tray[i] == 3.9):
			Place_39()

	pub.publish("next")


def subscriber():
	rospy.Subscriber("data_robot", trajectories, callback_msg)
	rospy.spin()

# ===================== PICK WAYPOINTS ===================== # 

def Pick_31():
    
    # ------ PICK of the BOX 3.1 ------

    # 1. Box3.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.1_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -121
    joint_goal[1] = CONV * -74
    joint_goal[2] = CONV * 76
    joint_goal[3] = CONV * -2
    joint_goal[4] = CONV * 148
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.1_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -137
    joint_goal[1] = CONV * -59
    joint_goal[2] = CONV * 53
    joint_goal[3] = CONV * 5
    joint_goal[4] = CONV * 132
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.1 Lift1 Position:
    print "4. STEP: MOVING ROBOT TO B3.1_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -137
    joint_goal[1] = CONV * -57
    joint_goal[2] = CONV * 39
    joint_goal[3] = CONV * 17
    joint_goal[4] = CONV * 132
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 4. Box3.1 Lift2 Position:
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -121
    joint_goal[1] = CONV * -72
    joint_goal[2] = CONV * 56
    joint_goal[3] = CONV * 15
    joint_goal[4] = CONV * 148
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_32():
    
    # ------ PICK of the BOX 3.2 ------

    # 1. Box3.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.2_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -138
    joint_goal[1] = CONV * -83
    joint_goal[2] = CONV * 85
    joint_goal[3] = CONV * -3
    joint_goal[4] = CONV * 131
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.2_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -146
    joint_goal[1] = CONV * -73
    joint_goal[2] = CONV * 72
    joint_goal[3] = CONV * 1
    joint_goal[4] = CONV * 124
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.2 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.2_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -138
    joint_goal[1] = CONV * -75
    joint_goal[2] = CONV * 44
    joint_goal[3] = CONV * 31
    joint_goal[4] = CONV * 131
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_33():
    
    # ------ PICK of the BOX 3.3 ------

    # 1. Box3.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.3_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -154
    joint_goal[1] = CONV * -94
    joint_goal[2] = CONV * 97
    joint_goal[3] = CONV * -3
    joint_goal[4] = CONV * 116
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.3_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -159
    joint_goal[1] = CONV * -84
    joint_goal[2] = CONV * 87
    joint_goal[3] = CONV * -3
    joint_goal[4] = CONV * 111
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.3 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.3_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -154
    joint_goal[1] = CONV * -86
    joint_goal[2] = CONV * 54
    joint_goal[3] = CONV * 32
    joint_goal[4] = CONV * 116
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_34():
    
    # ------ PICK of the BOX 3.4 ------

    # 1. Box3.4 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.4_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 39
    joint_goal[1] = CONV * -79
    joint_goal[2] = CONV * -132
    joint_goal[3] = CONV * 30
    joint_goal[4] = CONV * 52
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.4 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.4_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 29
    joint_goal[1] = CONV * -93
    joint_goal[2] = CONV * -119
    joint_goal[3] = CONV * 31
    joint_goal[4] = CONV * 61
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.4 Lift1 Position:
    print "4. STEP: MOVING ROBOT TO B3.4_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 29
    joint_goal[1] = CONV * -87
    joint_goal[2] = CONV * -109
    joint_goal[3] = CONV * 15
    joint_goal[4] = CONV * 62
    joint_goal[5] = CONV * -178
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 4. Box3.4 Lift2 Position:
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 38
    joint_goal[1] = CONV * -73
    joint_goal[2] = CONV * -120
    joint_goal[3] = CONV * 12
    joint_goal[4] = CONV * 53
    joint_goal[5] = CONV * -178
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_35():
    
    # ------ PICK of the BOX 3.5 ------

    # 1. Box3.5 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.5_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 16
    joint_goal[1] = CONV * -74
    joint_goal[2] = CONV * -136
    joint_goal[3] = CONV * 29
    joint_goal[4] = CONV * 74
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.5 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.5_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 11
    joint_goal[1] = CONV * -93
    joint_goal[2] = CONV * -120
    joint_goal[3] = CONV * 32
    joint_goal[4] = CONV * 80
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.5 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.5_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 14
    joint_goal[1] = CONV * -67
    joint_goal[2] = CONV * -109
    joint_goal[3] = CONV * -5
    joint_goal[4] = CONV * 76
    joint_goal[5] = CONV * -178
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_36():
    
    # ------ PICK of the BOX 3.6 ------

    # 1. Box3.6 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.6_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -11
    joint_goal[1] = CONV * -86
    joint_goal[2] = CONV * -127
    joint_goal[3] = CONV * 32
    joint_goal[4] = CONV * 101
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.6 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.6_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -8
    joint_goal[1] = CONV * -98
    joint_goal[2] = CONV * -115
    joint_goal[3] = CONV * 32
    joint_goal[4] = CONV * 98
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.6 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.6_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -12
    joint_goal[1] = CONV * -79
    joint_goal[2] = CONV * -95
    joint_goal[3] = CONV * -7
    joint_goal[4] = CONV * 102
    joint_goal[5] = CONV * -178
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_37():
    
    # ------ PICK of the BOX 3.7 ------

    # 1. Box3.7 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.7_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -33
    joint_goal[1] = CONV * -178
    joint_goal[2] = CONV * 84
    joint_goal[3] = CONV * 94
    joint_goal[4] = CONV * -123
    joint_goal[5] = CONV * 179
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.7 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.7_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -30
    joint_goal[1] = CONV * -177
    joint_goal[2] = CONV * 78
    joint_goal[3] = CONV * 99
    joint_goal[4] = CONV * -120
    joint_goal[5] = CONV * 179
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.7 Lift1 Position:
    print "4. STEP: MOVING ROBOT TO B3.7_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -36
    joint_goal[1] = CONV * -160
    joint_goal[2] = CONV * 67
    joint_goal[3] = CONV * 94
    joint_goal[4] = CONV * -125
    joint_goal[5] = CONV * 179
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)


    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_38():
    
    # ------ PICK of the BOX 3.8 ------

    # 1. Box3.8 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.8_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -48
    joint_goal[1] = CONV * -114
    joint_goal[2] = CONV * -95
    joint_goal[3] = CONV * 28
    joint_goal[4] = CONV * 138
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.8 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.8_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -41
    joint_goal[1] = CONV * -121
    joint_goal[2] = CONV * -84
    joint_goal[3] = CONV * 24
    joint_goal[4] = CONV * 130
    joint_goal[5] = CONV * -178
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.8 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.8_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -48
    joint_goal[1] = CONV * -108
    joint_goal[2] = CONV * -77
    joint_goal[3] = CONV * 4
    joint_goal[4] = CONV * 138
    joint_goal[5] = CONV * -178
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_39():
    
    # ------ PICK of the BOX 3.9 ------

    # 1. Box3.9 Approach Position:
    print "1. STEP: MOVING ROBOT TO B3.9_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -56
    joint_goal[1] = CONV * -169
    joint_goal[2] = CONV * 47
    joint_goal[3] = CONV * 122
    joint_goal[4] = CONV * -147
    joint_goal[5] = CONV * 179
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box3.9 Pick Position:
    print "2. STEP: MOVING ROBOT TO B3.9_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -48
    joint_goal[1] = CONV * -162
    joint_goal[2] = CONV * 26
    joint_goal[3] = CONV * 134
    joint_goal[4] = CONV * -137
    joint_goal[5] = CONV * 179
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box3.9 Lift Position:
    print "4. STEP: MOVING ROBOT TO B3.9_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -56
    joint_goal[1] = CONV * -148
    joint_goal[2] = CONV * 16
    joint_goal[3] = CONV * 132
    joint_goal[4] = CONV * -147
    joint_goal[5] = CONV * 179
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_21():
    
    # ------ PICK of the BOX 2.1 ------

    # 1. Box2.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.1_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -130
    joint_goal[1] = CONV * -62
    joint_goal[2] = CONV * 85
    joint_goal[3] = CONV * -23
    joint_goal[4] = CONV * 141
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.1 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.1_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -137
    joint_goal[1] = CONV * -56
    joint_goal[2] = CONV * 72
    joint_goal[3] = CONV * -17
    joint_goal[4] = CONV * 134
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.1 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.1_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -99
    joint_goal[1] = CONV * -74
    joint_goal[2] = CONV * 92
    joint_goal[3] = CONV * -19
    joint_goal[4] = CONV * 171
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_22():
    
    # ------ PICK of the BOX 2.2 ------

    # 1. Box2.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.2_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -135
    joint_goal[1] = CONV * -78
    joint_goal[2] = CONV * 107
    joint_goal[3] = CONV * -28
    joint_goal[4] = CONV * 135
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.2 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.2_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -146.5
    joint_goal[1] = CONV * -67
    joint_goal[2] = CONV * 93
    joint_goal[3] = CONV * -24
    joint_goal[4] = CONV * 124
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.2 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.2_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -125
    joint_goal[1] = CONV * -88
    joint_goal[2] = CONV * 105
    joint_goal[3] = CONV * -17
    joint_goal[4] = CONV * 146
    joint_goal[5] = CONV * 1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_23():
    
    # ------ PICK of the BOX 2.3 ------

    # 1. Box2.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.3_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -149
    joint_goal[1] = CONV * -91
    joint_goal[2] = CONV * 122
    joint_goal[3] = CONV * -30
    joint_goal[4] = CONV * 121
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.3 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.3_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -159
    joint_goal[1] = CONV * -76
    joint_goal[2] = CONV * 106
    joint_goal[3] = CONV * -29
    joint_goal[4] = CONV * 111
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.3 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.3_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -142
    joint_goal[1] = CONV * -100
    joint_goal[2] = CONV * 122
    joint_goal[3] = CONV * -21
    joint_goal[4] = CONV * 128
    joint_goal[5] = CONV * 1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_24():
    
    # ------ PICK of the BOX 2.4 ------

    # 1. Box2.4 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.4_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 78
    joint_goal[1] = CONV * -51
    joint_goal[2] = CONV * -144
    joint_goal[3] = CONV * -169
    joint_goal[4] = CONV * -12
    joint_goal[5] = CONV * 4
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.4 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.4_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 29
    joint_goal[1] = CONV * -94
    joint_goal[2] = CONV * -117
    joint_goal[3] = CONV * -150
    joint_goal[4] = CONV * -61
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.4 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.4_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 78
    joint_goal[1] = CONV * -49
    joint_goal[2] = CONV * -138
    joint_goal[3] = CONV * -176
    joint_goal[4] = CONV * -12
    joint_goal[5] = CONV * 4
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_25():
    
    # ------ PICK of the BOX 2.5 ------

    # 1. Box2.5 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.5_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 128
    joint_goal[1] = CONV * -124
    joint_goal[2] = CONV * 143
    joint_goal[3] = CONV * -19
    joint_goal[4] = CONV * 38
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.5 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.5_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 157
    joint_goal[1] = CONV * -86
    joint_goal[2] = CONV * 117
    joint_goal[3] = CONV * -31
    joint_goal[4] = CONV * 67
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.5 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.5_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 120
    joint_goal[1] = CONV * -131
    joint_goal[2] = CONV * 137
    joint_goal[3] = CONV * -5
    joint_goal[4] = CONV * 29
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_26():
    
    # ------ PICK of the BOX 2.6 ------

    # 1. Box2.6 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.6_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 94
    joint_goal[1] = CONV * -116
    joint_goal[2] = CONV * 140
    joint_goal[3] = CONV * -24
    joint_goal[4] = CONV * 3
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.6 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.6_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 141
    joint_goal[1] = CONV * -81
    joint_goal[2] = CONV * 113
    joint_goal[3] = CONV * -31
    joint_goal[4] = CONV * 50
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.6 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.6_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 110
    joint_goal[1] = CONV * -111
    joint_goal[2] = CONV * 132
    joint_goal[3] = CONV * -21
    joint_goal[4] = CONV * 19
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_27():
    
    # ------ PICK of the BOX 2.7 ------

    # 1. Box2.7 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.7_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 97
    joint_goal[1] = CONV * -86
    joint_goal[2] = CONV * 119
    joint_goal[3] = CONV * -32
    joint_goal[4] = CONV * 6
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.7 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.7_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 125
    joint_goal[1] = CONV * -70
    joint_goal[2] = CONV * 97
    joint_goal[3] = CONV * -28
    joint_goal[4] = CONV * 35
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.7 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.7_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 97
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 114
    joint_goal[3] = CONV * -24
    joint_goal[4] = CONV * 6
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_28():
    
    # ------ PICK of the BOX 2.8 ------

    # 1. Box2.8 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.8_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 92
    joint_goal[1] = CONV * -73
    joint_goal[2] = CONV * 102
    joint_goal[3] = CONV * -29
    joint_goal[4] = CONV * 2
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.8 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.8_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 118
    joint_goal[1] = CONV * -59
    joint_goal[2] = CONV * 82
    joint_goal[3] = CONV * -23
    joint_goal[4] = CONV * 29
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.8 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.8_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 92
    joint_goal[1] = CONV * -75
    joint_goal[2] = CONV * 99
    joint_goal[3] = CONV * -24
    joint_goal[4] = CONV * 2
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_29():
    
    # ------ PICK of the BOX 2.9 ------

    # 1. Box2.9 Approach Position:
    print "1. STEP: MOVING ROBOT TO B2.9_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -67
    joint_goal[1] = CONV * -121
    joint_goal[2] = CONV * -80
    joint_goal[3] = CONV * -159
    joint_goal[4] = CONV * -157
    joint_goal[5] = CONV * 1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box2.9 Pick Position:
    print "2. STEP: MOVING ROBOT TO B2.9_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -49
    joint_goal[1] = CONV * -134
    joint_goal[2] = CONV * -59
    joint_goal[3] = CONV * -167
    joint_goal[4] = CONV * -140
    joint_goal[5] = CONV * 1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box2.9 Lift Position:
    print "4. STEP: MOVING ROBOT TO B2.9_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -67
    joint_goal[1] = CONV * -120
    joint_goal[2] = CONV * -78
    joint_goal[3] = CONV * -162
    joint_goal[4] = CONV * -157
    joint_goal[5] = CONV * 1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_11():
    
    # ------ PICK of the BOX 1.1 ------

    # 1. Box1.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.1_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -115
    joint_goal[1] = CONV * -54
    joint_goal[2] = CONV * 104
    joint_goal[3] = CONV * -50
    joint_goal[4] = CONV * 155
    joint_goal[5] = CONV * -1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.1 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.1_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -137
    joint_goal[1] = CONV * -44
    joint_goal[2] = CONV * 84
    joint_goal[3] = CONV * -42
    joint_goal[4] = CONV * 134
    joint_goal[5] = CONV * -1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.1 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.1_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -115
    joint_goal[1] = CONV * -57
    joint_goal[2] = CONV * 104
    joint_goal[3] = CONV * -47
    joint_goal[4] = CONV * 155
    joint_goal[5] = CONV * -1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_12():
    
    # ------ PICK of the BOX 1.2 ------

    # 1. Box1.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.2_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -132
    joint_goal[1] = CONV * -62
    joint_goal[2] = CONV * 118
    joint_goal[3] = CONV * -56
    joint_goal[4] = CONV * 138
    joint_goal[5] = CONV * 2
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.2 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.2_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -147
    joint_goal[1] = CONV * -52
    joint_goal[2] = CONV * 100
    joint_goal[3] = CONV * -48
    joint_goal[4] = CONV * 124
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.2 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.2_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -132
    joint_goal[1] = CONV * -65
    joint_goal[2] = CONV * 118
    joint_goal[3] = CONV * -52
    joint_goal[4] = CONV * 138
    joint_goal[5] = CONV * 2
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_13():
    
    # ------ PICK of the BOX 1.3 ------

    # 1. Box1.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.3_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -144
    joint_goal[1] = CONV * -71
    joint_goal[2] = CONV * 138
    joint_goal[3] = CONV * -66
    joint_goal[4] = CONV * 126
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.3 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.3_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -159
    joint_goal[1] = CONV * -60
    joint_goal[2] = CONV * 115
    joint_goal[3] = CONV * -55
    joint_goal[4] = CONV * 111
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.3 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.3_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -144
    joint_goal[1] = CONV * -80
    joint_goal[2] = CONV * 136
    joint_goal[3] = CONV * -56
    joint_goal[4] = CONV * 126
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_14():
    
    # ------ PICK of the BOX 1.4 ------

    # 1. Box1.4 Approach1 Position:
    print "1. STEP: MOVING ROBOT TO B1.4_APPROACH1 POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 140
    joint_goal[1] = CONV * -100
    joint_goal[2] = CONV * -153
    joint_goal[3] = CONV * -107
    joint_goal[4] = CONV * -39
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    #rospy.sleep(1)

    # 2. Box1.4 Approach2 Position:
    print "2. STEP: MOVING ROBOT TO B1.4_APPROACH2 POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 51
    joint_goal[1] = CONV * -100
    joint_goal[2] = CONV * -153
    joint_goal[3] = CONV * -107
    joint_goal[4] = CONV * -39
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.4 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.4_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 30
    joint_goal[1] = CONV * -114
    joint_goal[2] = CONV * -127
    joint_goal[3] = CONV * -119
    joint_goal[4] = CONV * -62
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.4 Lift1 Position:
    print "4. STEP: MOVING ROBOT TO B1.4_LIFT1 POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 51
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * -151
    joint_goal[3] = CONV * -118
    joint_goal[4] = CONV * -39
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    #rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 4. Box1.4 Lift2 Position:
    print "4. STEP: MOVING ROBOT TO B1.4_LIFT2 POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 150
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * -151
    joint_goal[3] = CONV * -118
    joint_goal[4] = CONV * -39
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_15():
    
    # ------ PICK of the BOX 1.5 ------

    # 1. Box1.5 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.5_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 143
    joint_goal[1] = CONV * -77
    joint_goal[2] = CONV * 149
    joint_goal[3] = CONV * -72
    joint_goal[4] = CONV * 53
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.5 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.5_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 156
    joint_goal[1] = CONV * -66
    joint_goal[2] = CONV * 128
    joint_goal[3] = CONV * -62
    joint_goal[4] = CONV * 67
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.5 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.5_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 130
    joint_goal[1] = CONV * -97
    joint_goal[2] = CONV * 157
    joint_goal[3] = CONV * -60
    joint_goal[4] = CONV * 40
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_16():
    
    # ------ PICK of the BOX 1.6 ------

    # 1. Box1.6 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.6_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 120
    joint_goal[1] = CONV * -75
    joint_goal[2] = CONV * 145
    joint_goal[3] = CONV * -70
    joint_goal[4] = CONV * 30
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.6 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.6_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 140
    joint_goal[1] = CONV * -63
    joint_goal[2] = CONV * 123
    joint_goal[3] = CONV * -60
    joint_goal[4] = CONV * 51
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.6 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.6_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 120
    joint_goal[1] = CONV * -82
    joint_goal[2] = CONV * 144
    joint_goal[3] = CONV * -62
    joint_goal[4] = CONV * 30
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_17():
    
    # ------ PICK of the BOX 1.7 ------

    # 1. Box1.7 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.7_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 93
    joint_goal[1] = CONV * -67
    joint_goal[2] = CONV * 131
    joint_goal[3] = CONV * -64
    joint_goal[4] = CONV * 4
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.7 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.7_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 125
    joint_goal[1] = CONV * -55
    joint_goal[2] = CONV * 106
    joint_goal[3] = CONV * -52
    joint_goal[4] = CONV * 37
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.7 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.7_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 93
    joint_goal[1] = CONV * -70
    joint_goal[2] = CONV * 131
    joint_goal[3] = CONV * -60
    joint_goal[4] = CONV * 4
    joint_goal[5] = CONV * 0
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_18():
    
    # ------ PICK of the BOX 1.8 ------

    # 1. Box1.8 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.8_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 102
    joint_goal[1] = CONV * -56
    joint_goal[2] = CONV * 108
    joint_goal[3] = CONV * -54
    joint_goal[4] = CONV * 13
    joint_goal[5] = CONV * 1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.8 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.8_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 118
    joint_goal[1] = CONV * -47
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * -43
    joint_goal[4] = CONV * 30
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.8 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.8_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 102
    joint_goal[1] = CONV * -60
    joint_goal[2] = CONV * 107
    joint_goal[3] = CONV * -49
    joint_goal[4] = CONV * 13
    joint_goal[5] = CONV * 1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Pick_19():
    
    # ------ PICK of the BOX 1.9 ------

    # 1. Box1.9 Approach Position:
    print "1. STEP: MOVING ROBOT TO B1.9_APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 98
    joint_goal[1] = CONV * -45
    joint_goal[2] = CONV * 85
    joint_goal[3] = CONV * -41
    joint_goal[4] = CONV * 7
    joint_goal[5] = CONV * 1
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Box1.9 Pick Position:
    print "2. STEP: MOVING ROBOT TO B1.9_PICK POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 113
    joint_goal[1] = CONV * -36
    joint_goal[2] = CONV * 67
    joint_goal[3] = CONV * -31
    joint_goal[4] = CONV * 23
    joint_goal[5] = CONV * 0
    
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)
	
    # 3. Close GRIPPER:
    print "3. STEP: CLOSING GRIPPER"
    t_end = time.time() + 3
    while time.time() < t_end:
    	publisher("close")

    move_group.set_max_velocity_scaling_factor(0.2)
    move_group.set_max_acceleration_scaling_factor(0.2)

    # 4. Box1.9 Lift Position:
    print "4. STEP: MOVING ROBOT TO B1.9_LIFT POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 98
    joint_goal[1] = CONV * -47
    joint_goal[2] = CONV * 85
    joint_goal[3] = CONV * -39
    joint_goal[4] = CONV * 7
    joint_goal[5] = CONV * 1
	
    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.set_max_velocity_scaling_factor(1)
    move_group.set_max_acceleration_scaling_factor(1)

    # 5. Pick-Place Position:
    print "5. STEP: MOVING ROBOT TO PICK_END POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)


# ===================== PLACE WAYPOINTS ===================== # 

def Place_11():
   
    # 1. Tray1.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY1.1 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -69
    joint_goal[1] = CONV * -44
    joint_goal[2] = CONV * 106
    joint_goal[3] = CONV * -154
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 23

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray1.1 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY1.1 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -68
    joint_goal[1] = CONV * -33
    joint_goal[2] = CONV * 103
    joint_goal[3] = CONV * -161
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 23

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_12():
   
    # 1. Tray1.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY1.2 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -61
    joint_goal[1] = CONV * -50
    joint_goal[2] = CONV * 126
    joint_goal[3] = CONV * -168
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 30

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray1.2 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY1.2 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -61
    joint_goal[1] = CONV * -35
    joint_goal[2] = CONV * 121
    joint_goal[3] = CONV * -178
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 31

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_13():
   
    # 1. Tray1.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY1.3 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -50
    joint_goal[1] = CONV * -47
    joint_goal[2] = CONV * 112
    joint_goal[3] = CONV * -157
    joint_goal[4] = CONV * -91
    joint_goal[5] = CONV * 40

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray1.3 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY1.3 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -50
    joint_goal[1] = CONV * -33
    joint_goal[2] = CONV * 108
    joint_goal[3] = CONV * -167
    joint_goal[4] = CONV * -91
    joint_goal[5] = CONV * 40

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_14():
   
    # 1. Tray1.4 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY1.4 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -59
    joint_goal[1] = CONV * -39
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * -142
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 31

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray1.4 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY1.4 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -59
    joint_goal[1] = CONV * -27
    joint_goal[2] = CONV * 87
    joint_goal[3] = CONV * -150
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 31

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_21():
   
    # 1. Tray2.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.1 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -36
    joint_goal[1] = CONV * -69
    joint_goal[2] = CONV * 118
    joint_goal[3] = CONV * 41
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -126

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.1 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.1 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -34
    joint_goal[1] = CONV * -40
    joint_goal[2] = CONV * 116
    joint_goal[3] = CONV * 13
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -125

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_22():
   
    # 1. Tray2.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.2 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -26
    joint_goal[1] = CONV * -57
    joint_goal[2] = CONV * 99
    joint_goal[3] = CONV * 48
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -116

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.2 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.2 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -26
    joint_goal[1] = CONV * -31
    joint_goal[2] = CONV * 97
    joint_goal[3] = CONV * 24
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -116

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_23():
   
    # 1. Tray2.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.3 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -22
    joint_goal[1] = CONV * -68
    joint_goal[2] = CONV * 112
    joint_goal[3] = CONV * -133
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 68

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.3 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.3 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -22
    joint_goal[1] = CONV * -36
    joint_goal[2] = CONV * 110
    joint_goal[3] = CONV * -163
    joint_goal[4] = CONV * -89
    joint_goal[5] = CONV * 69

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_24():
   
    # 1. Tray2.4 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.4 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -7
    joint_goal[1] = CONV * -47
    joint_goal[2] = CONV * 120
    joint_goal[3] = CONV * 16
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -98

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.4 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.4 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -7
    joint_goal[1] = CONV * -38
    joint_goal[2] = CONV * 118
    joint_goal[3] = CONV * 10
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -98

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_25():
   
    # 1. Tray2.5 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.5 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -5
    joint_goal[1] = CONV * -45
    joint_goal[2] = CONV * 102
    joint_goal[3] = CONV * 32
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -96

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.5 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.5 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -5
    joint_goal[1] = CONV * -33
    joint_goal[2] = CONV * 99
    joint_goal[3] = CONV * 23
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -96

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_26():
   
    # 1. Tray2.6 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY2.6 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -5
    joint_goal[1] = CONV * -45
    joint_goal[2] = CONV * 79
    joint_goal[3] = CONV * 54
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -96

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray2.6 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY2.6 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * -4
    joint_goal[1] = CONV * -25
    joint_goal[2] = CONV * 77
    joint_goal[3] = CONV * 37
    joint_goal[4] = CONV * 89
    joint_goal[5] = CONV * -95

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_31():
   
    # 1. Tray3.1 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.1 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 34
    joint_goal[1] = CONV * -49
    joint_goal[2] = CONV * 97
    joint_goal[3] = CONV * 41
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -58

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.1 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.1 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 34
    joint_goal[1] = CONV * -31
    joint_goal[2] = CONV * 93
    joint_goal[3] = CONV * 26
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -58

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_32():
   
    # 1. Tray3.2 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.2 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 46
    joint_goal[1] = CONV * -41
    joint_goal[2] = CONV * 70
    joint_goal[3] = CONV * 59
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -45

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.2 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.2 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 47
    joint_goal[1] = CONV * -20
    joint_goal[2] = CONV * 66
    joint_goal[3] = CONV * 44
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -44

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_33():
   
    # 1. Tray3.3 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.3 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 55
    joint_goal[1] = CONV * -12
    joint_goal[2] = CONV * 23
    joint_goal[3] = CONV * 79
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -36

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.3 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.3 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 55
    joint_goal[1] = CONV * 4
    joint_goal[2] = CONV * 10
    joint_goal[3] = CONV * 75
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -36

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_34():
   
    # 1. Tray3.4 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.4 APPRIACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 48
    joint_goal[1] = CONV * 30
    joint_goal[2] = CONV * -70
    joint_goal[3] = CONV * -52
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 137

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.4 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.4 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 45
    joint_goal[1] = CONV * 43
    joint_goal[2] = CONV * -65
    joint_goal[3] = CONV * -69
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 137

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_35():
   
    # 1. Tray3.5 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.5 APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 40
    joint_goal[1] = CONV * -28
    joint_goal[2] = CONV * 47
    joint_goal[3] = CONV * 71
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -51

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.5 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.5 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 39
    joint_goal[1] = CONV * -11
    joint_goal[2] = CONV * 45
    joint_goal[3] = CONV * 57
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -52

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_36():
   
    # 1. Tray3.6 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.6 APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 27
    joint_goal[1] = CONV * -40
    joint_goal[2] = CONV * 77
    joint_goal[3] = CONV * 53
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -64

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.6 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.6 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 27
    joint_goal[1] = CONV * -23
    joint_goal[2] = CONV * 74
    joint_goal[3] = CONV * 39
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -64

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_37():
   
    # 1. Tray3.7 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.7 APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 23
    joint_goal[1] = CONV * -30
    joint_goal[2] = CONV * 53
    joint_goal[3] = CONV * 67
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -68

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.7 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.7 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 23
    joint_goal[1] = CONV * -13
    joint_goal[2] = CONV * 50
    joint_goal[3] = CONV * 53
    joint_goal[4] = CONV * 90
    joint_goal[5] = CONV * -69

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_38():
   
    # 1. Tray3.8 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.8 APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 34
    joint_goal[1] = CONV * -45
    joint_goal[2] = CONV * 78
    joint_goal[3] = CONV * -122
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 123

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.8 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.8 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 34
    joint_goal[1] = CONV * -24
    joint_goal[2] = CONV * 76
    joint_goal[3] = CONV * -142
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 123

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

def Place_39():
   
    # 1. Tray3.9 Approach Position:
    print "1. STEP: MOVING ROBOT TO TRAY3.9 APPROACH POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 44
    joint_goal[1] = CONV * -28
    joint_goal[2] = CONV * 44
    joint_goal[3] = CONV * -106
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 133

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 2. Tray3.9 Place Position:
    print "2. STEP: MOVING ROBOT TO TRAY3.9 PLACE POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 44
    joint_goal[1] = CONV * -9
    joint_goal[2] = CONV * 42
    joint_goal[3] = CONV * -122
    joint_goal[4] = CONV * -90
    joint_goal[5] = CONV * 133

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)

    # 3. Open GRIPPER:
    print "3. STEP: OPENING GRIPPER"
    t_end = time.time() + 1
    while time.time() < t_end:
    	publisher("open")

    # 5. HOME Position:
    print "4. STEP: MOVING ROBOT TO HOME POSITION"
    joint_goal = move_group.get_current_joint_values()
    joint_goal[0] = CONV * 0
    joint_goal[1] = CONV * -90
    joint_goal[2] = CONV * 90
    joint_goal[3] = CONV * 0
    joint_goal[4] = CONV * 0
    joint_goal[5] = CONV * 0

    move_group.go(joint_goal, wait=True)
    rospy.sleep(1)


# ================================= MAIN =================================      
if __name__ == '__main__':
    try:

	# We initialize the node:
	rospy.init_node('robot_control', log_level = rospy.INFO)

	# We initialize moveit_commander, and robot, scene and arm (manipulator) groups:
        moveit_commander.roscpp_initialize(sys.argv)
	robot = moveit_commander.RobotCommander() 
	scene = moveit_commander.PlanningSceneInterface()
	group_name="manipulator"
	move_group = moveit_commander.MoveGroupCommander(group_name)

	# SPEED AND ACCELERATION SET-UP:
	moveit_commander.move_group.MoveGroupCommander.set_max_velocity_scaling_factor(move_group, 1)
	moveit_commander.move_group.MoveGroupCommander.set_max_acceleration_scaling_factor(move_group, 1)

	# INITIAL STEP -> Move to HomePosition
	print "INITIAL STEP: MOVING ROBOT TO HOME POSITION"
    	joint_goal = move_group.get_current_joint_values()
    	joint_goal[0] = CONV * 0
    	joint_goal[1] = CONV * -90
    	joint_goal[2] = CONV * 90
    	joint_goal[3] = CONV * 0
    	joint_goal[4] = CONV * 0
    	joint_goal[5] = CONV * 0
	
   	move_group.go(joint_goal, wait=True)
    	rospy.sleep(1)

	# LISTEN TO COMMANDS:
	subscriber()	


    except rospy.ROSInterruptException:
        print ("Program interrupted before completion!")

